<template>
  <div class="scroll">
    <div class="middle">
      <div class="filter">
        <div class="condition">
          <span>组织名称 :</span>
          <el-input
            clearable
            v-model.trim="searchInput.name"
            class="w-50 m-2"
            placeholder="请输入组织名称"
            style="width: 180px"
          />
        </div>
        <div class="condition">
          <span>组织分类 :</span>
          <el-select
            clearable
            v-model="searchInput.categoryId"
            placeholder="请选择组织分类"
          >
            <el-option
              v-for="i in categoryData"
              :key="i.id"
              :label="i.name"
              :value="i.id"
            />
          </el-select>
        </div>
        <div class="condition">
          <span>联系人 :</span>
          <el-input
            clearable
            v-model.trim="searchInput.contractPerson"
            class="w-50 m-2"
            placeholder="请输入联系人"
            style="width: 180px"
          />
        </div>
        <el-button
          style="margin-left: 20px"
          color="rgba(38, 151, 255, 1)"
          type="primary"
          class="search"
          @click="searchBtn"
          ><span>查询</span></el-button
        >
        <el-button @click="resetBtn" plain color="rgba(43, 153, 255, 1)"
          >重置</el-button
        >
      </div>
      <!-- 按钮列表 -->
      <div class="gongneng">
        <el-button
          type="primary"
          style="margin-left: 0"
          color="rgba(38, 151, 255, 1)"
          @click="addlist"
          >创建组织</el-button
        >
      </div>
    </div>
    <div class="footer" v-loading="loading">
      <el-table
        :row-class-name="tableRowClassName"
        :data="tableData.list"
        @selection-change="handleSelectionChange"
        style="width: 100%"
        :header-cell-style="{
          background: 'rgba(240, 243, 247, 1)',
          height: '50px',
          border: 0,
        }"
      >
        <!-- <el-table-column type="selection" align="center" width="55" /> -->
        <el-table-column type="index" align="center" label="序号" width="60" />
        <el-table-column align="center" prop="name" label="组织名称" />
        <el-table-column
          width="100"
          align="center"
          prop="categoryName"
          label="组织分类"
        >
        </el-table-column>
        <el-table-column align="center" prop="dormitory" label="组织城市">
          <template #default="{ row }">
            {{ row.province }}-{{ row.city }}
          </template>
        </el-table-column>
        <el-table-column
          show-overflow-tooltip
          align="center"
          prop="description"
          label="组织介绍"
        />
        <el-table-column align="center" label="分会标识">
          <template #default="{ row }">
            <img
              v-viewer
              v-if="row.branchIde"
              :src="row.branchIde"
              alt="图片预览"
              class="preview-img"
              style="width: 60px; height: 60px; margin: 10px 0"
            />
          </template>
        </el-table-column>
        <el-table-column align="center" prop="clubNum" label="成员人数" />
        <el-table-column align="center" prop="contractPerson" label="联系人" />
        <el-table-column align="center" prop="contractInfo" label="联系方式" />
        <el-table-column align="center" prop="createTime" label="创建时间" />
        <el-table-column align="center" label="操作" fixed="right" width="200">
          <template #default="{ row }">
            <el-button type="primary" @click="clubTopupClick(row)" link
              >置顶</el-button
            >
            <el-button type="primary" @click="updateS(row)" link
              >编辑</el-button
            >
            <el-button type="danger" @click="deleteS(row)" link>删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <!-- 分页组件 -->
      <div class="pageSize">
        <span></span>
        <el-pagination
          background
          :current-page="currentPage"
          :page-size="pageSize"
          :page-sizes="[10, 20, 30, 40]"
          layout="total,sizes, prev, pager, next, jumper, slot"
          :total="total"
          @size-change="handleSizeChange"
          @update:current-page="handleCurrentChange"
        />
      </div>
    </div>
  </div>
  <!-- 添加账号弹窗 -->
  <el-dialog
    class="addStaff"
    v-model="addDialogVisible"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    :title="dialongTitle"
    align-center
    width="560"
    :before-close="cancelAdd"
    destroy-on-close
    draggable
  >
    <el-form
      ref="ruleFormRef"
      :model="ruleForm"
      :rules="rules"
      label-width="100px"
      class="demo-ruleForm"
      :size="formSize"
      label-position="right"
      status-icon
    >
      <el-form-item label="组织名称 :" prop="name">
        <el-input
          clearable
          v-model.trim="ruleForm.name"
          class="w-50 m-2"
          placeholder="请输入组织名称"
        />
      </el-form-item>
      <el-form-item label="组织分类 :" prop="categoryId">
        <el-select
          v-model="ruleForm.categoryId"
          clearable
          placeholder="请选择组织分类"
        >
          <el-option
            v-for="i in categoryData"
            :key="i.id"
            :label="i.name"
            :value="`${i.id}-${i.name}`"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="组织城市 :" prop="cityId">
        <div>
          <el-select
            v-model="ruleForm.provinceId"
            placeholder="请选择省"
            style="width: 140px"
            @change="provincesChange"
          >
            <el-option
              v-for="item in provinceList"
              :key="item.id"
              :label="item.name"
              :value="`${item.id}-${item.name}`"
            />
          </el-select>
          <span> - </span>
          <el-select
            v-model="ruleForm.cityId"
            placeholder="请选择市"
            style="width: 140px"
          >
            <el-option
              v-for="item in cityList"
              :key="item.id"
              :label="item.name"
              :value="`${item.id}-${item.name}`"
            />
          </el-select>
        </div>
      </el-form-item>
      <el-form-item label="组织介绍 :" prop="description">
        <el-input
          v-model.trim="ruleForm.description"
          placeholder="请输入组织介绍"
          clearable
          :autosize="{ minRows: 4 }"
          type="textarea"
        />
      </el-form-item>
      <el-form-item label="联系人 :" prop="contractPerson">
        <el-input
          clearable
          v-model.trim="ruleForm.contractPerson"
          class="w-50 m-2"
          placeholder="请输入联系人"
        />
      </el-form-item>
      <el-form-item label="手机号码 :" prop="contractInfo">
        <el-input
          clearable
          v-model.trim="ruleForm.contractInfo"
          class="w-50 m-2"
          placeholder="请输入手机号码"
        />
      </el-form-item>
      <el-form-item label="分会标识 :" prop="branchIde">
        <div class="img-preview-list">
          <div class="img-item" v-if="ruleForm.branchIde">
            <img
              :src="ruleForm.branchIde"
              alt="图片预览"
              class="preview-img"
              v-viewer
            />
            <span class="delete-btn" @click="handleDelete">
              <el-icon><Delete /></el-icon>
            </span>
          </div>
          <el-upload
            action="#"
            :auto-upload="false"
            :on-change="handleFileChange"
            :before-upload="beforeUpload"
            class="upload-btn"
            accept="image/*"
          >
            <el-icon><Plus /></el-icon>
            <span class="upload-txt">点击上传图片</span>
          </el-upload>
        </div>
      </el-form-item>
      <el-form-item label="置顶 :" prop="isTop">
        <el-radio-group v-model="ruleForm.isTop">
          <el-radio :value="1">是</el-radio>
          <el-radio :value="2">否</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item class="options">
        <el-button @click="cancelAdd">取消</el-button>
        <el-button
          color="rgba(0, 97, 255, 1)"
          class="queding"
          type="primary"
          @click="submitAdd(ruleFormRef)"
        >
          确定
        </el-button>
      </el-form-item>
    </el-form>
  </el-dialog>
  <!-- 项目导入 -->
  <el-dialog
    class="projectImport"
    v-model="buildImportVisible"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    title="寝室信息导入"
    align-center
    width="600"
    :before-close="cancelProjectImport"
  >
    <!-- <p class="title">当前只支持项目类型为“非装配式建筑项目”的项目导入</p> -->
    <p class="down">
      <span>寝室信息导入模板下载</span
      ><span @click="templateDown">模板下载</span>
    </p>
    <el-upload
      class="avatar-uploader"
      action="#"
      :auto-upload="false"
      :on-remove="projectImportRemove"
      :on-change="projectImportChange"
      :before-upload="beforeAvatarProImport"
      ref="buildRef"
      :limit="1"
      :on-exceed="projectImportExceed"
    >
      <template #trigger>
        <el-button class="queding" type="primary">
          &nbsp;&nbsp;导入文件&nbsp;&nbsp;
        </el-button>
      </template>
    </el-upload>
    <div class="options">
      <el-button
        color="rgba(9, 101, 98, 1)"
        class="queding"
        type="primary"
        @click="projectImportConfirm(buildRef)"
        :loading="buildImportLoading"
      >
        &nbsp;&nbsp;确认导入&nbsp;&nbsp;
      </el-button>
      <el-button @click="cancelProjectImport"
        >&nbsp;&nbsp;取消导入&nbsp;&nbsp;</el-button
      >
    </div>
  </el-dialog>
</template>

<script setup>
import {
  ref,
  watch,
  reactive,
  nextTick,
  onBeforeMount,
  onUnmounted,
} from "vue";
import { useRouter } from "vue-router";
import { genFileId, ElMessage, ElMessageBox } from "element-plus";
import { dayjs } from "element-plus";
import lodash from "lodash";
import { Delete, Download, Plus, ZoomIn } from "@element-plus/icons-vue";
import { storeToRefs } from "pinia";
import { useCounterStore } from "@/stores/index";
import { api as viewerApi } from "v-viewer";

import {
  getQueryClubPage,
  getQueryOrgTree,
  getAlumniClubExcel,
  getQueryCategoryDatas,
  insertClubData,
  updateClubData,
  deleteClubById,
  clubTopup,
  getProvinceLevel,
  getCityLevel,
} from "@/api/alumni-organization.js";
import { uploadFile } from "@/api/uploadFile";

const router = useRouter();
const store = useCounterStore();

// 为避免解构时失去响应性
const { name, age, isCollapse, realAge, collegeRole } = storeToRefs(store);

const handleDelete = () => {
  ruleForm.branchIde = "";
};

const handlePreview = (images) => {
  // 传给预览器，此时插件显示的第一张就是点击的图片
  viewerApi({
    images: images,
    zIndex: 3000,
  });
};

// 上传前的校验
const beforeUpload = (file) => {
  // 校验文件类型
  const isImage = file.type.startsWith("image/");
  if (!isImage) {
    ElMessage.error("只能上传图片格式文件");
    return false;
  }
  // 校验文件大小（2MB）
  const isLt2M = file.size / 1024 / 1024 < 2;
  if (!isLt2M) {
    ElMessage.error("图片大小不能超过2MB");
    return false;
  }
  return true;
};

// 文件选择变化时触发
const handleFileChange = async (file, newFileList) => {
  console.log(file);
  let formData = new FormData();
  formData.append("file", file.raw);
  let res = await uploadFile(formData);
  // console.log(res.data.fileUrl);
  if (res.code == 200) {
    ruleForm.branchIde = res.data.fileUrl; // 赋值给响应式fileList，页面自动刷新
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

// 表格数据
const loading = ref(false);
const tableData = reactive({
  list: [{}],
});
const activeIndex = ref(); // 默认跳转路由
const dialongTitle = ref("新增账号"); // 弹窗标题

const searchInput = reactive({
  name: "",
  categoryId: null,
  contractPerson: null,
}); // 搜索按钮数据

const currentPage = ref(1); // 当前页
const pageSize = ref(10);
const total = ref(0); // 当前总数
const selectIds = ref([]); // 勾选的全部数据

const categoryData = ref();
const provinceList = ref([]);
const cityList = ref([]);

const addDialogVisible = ref(false); // 控制添加账号弹窗

// 表单数据
const formSize = ref("default");
const ruleFormRef = ref();
const ruleForm = reactive({
  name: "",
  categoryId: "",
  provinceId: "",
  cityId: "",
  description: "",
  contractPerson: "",
  contractInfo: "",
  branchIde: "",
  isTop: 2, // 是：1   否：2
  id: "",
});
// 表单验证
const rules = reactive({
  name: [{ required: true, message: "组织名称不能为空", trigger: "blur" }],
  categoryId: [
    { required: true, message: "所属分类不能为空", trigger: "blur" },
  ],
  provinceId: [{ required: true, message: "省名称不能为空", trigger: "blur" }],
  cityId: [{ required: true, message: "市名称不能为空", trigger: "blur" }],
  description: [
    { required: true, message: "组织介绍不能为空", trigger: "blur" },
  ],
  contractPerson: [
    { required: true, message: "联系人不能为空", trigger: "blur" },
  ],
  contractInfo: [
    { required: true, message: "联系方式不能为空", trigger: "blur" },
  ],
  branchIde: [{ required: true, message: "分会标识不能为空", trigger: "blur" }],
});

// 获取账户列表
const getList = async () => {
  loading.value = true;
  let params = {
    currentPage: currentPage.value, // 当前页
    pageCount: pageSize.value, // 一页数据条数
    categoryId: searchInput.categoryId,
    name: searchInput.name,
    contractPerson: searchInput.contractPerson,
  };
  getQueryClubPage(params).then((res) => {
    console.log(res, "校友组织分页数据");
    if (res.code == 200) {
      tableData.list = res.data.list;
      total.value = res.data.totalCount;
      loading.value = false;
    } else {
      loading.value = false;
    }
  });
};

// 搜索功能
const searchBtn = lodash.debounce(async () => {
  currentPage.value = 1;
  getList();
}, 300);
const resetBtn = lodash.debounce(async () => {
  searchInput.categoryId = "";
  searchInput.name = "";
  searchInput.contractPerson = null;
  currentPage.value = 1;
  getList();
}, 300);

const deleteS = async (row) => {
  ElMessageBox.confirm("是否删除此数据?", "提示!!!", {
    confirmButtonText: "确认",
    cancelButtonText: "取消",
    type: "warning",
  })
    .then(async () => {
      let params = {
        id: row.id,
      };
      let res = await deleteClubById(params);
      if (res.code == 200) {
        getList();
        ElMessage({
          type: "success",
          showClose: true,
          message: res.message,
          center: true,
        });
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: res.message,
          center: true,
        });
      }
    })
    .catch(() => {
      loading.value = false;
    });
};
// 添加账号
const addlist = () => {
  dialongTitle.value = "创建组织";
  addDialogVisible.value = true;
  ruleForm.name = "";
  ruleForm.categoryId = null;
  ruleForm.provinceId = null;
  ruleForm.cityId = null;
  cityList.value = [];
  ruleForm.description = null;
  ruleForm.contractPerson = null;
  ruleForm.contractInfo = null;
  ruleForm.branchIde = null;
  ruleForm.isTop = 2;
  ruleForm.id = null;
};
// 添加账号
const updateS = async (row) => {
  console.log(row);
  dialongTitle.value = "编辑组织";
  addDialogVisible.value = true;
  ruleForm.name = row.name;
  ruleForm.categoryId = `${row.categoryId}-${row.categoryName}`;
  if (row.provinceId) {
    ruleForm.provinceId = `${row.provinceId}-${row.province}`;
    getCityLevel({ provinceId: row.provinceId }).then((res) => {
      cityList.value = res.data;
    });
    ruleForm.cityId = `${row.cityId}-${row.city}`;
  } else {
    ruleForm.provinceId = [];
    ruleForm.cityId = [];
  }
  ruleForm.description = row.description;
  ruleForm.contractPerson = row.contractPerson;
  ruleForm.contractInfo = row.contractInfo;
  ruleForm.branchIde = row.branchIde;
  ruleForm.isTop = row.isTop;
  ruleForm.id = row.id;
  let params = {
    provinceId: row.cityId,
  };
  getCityLevel(params).then((res) => {});
};
const provincesChange = async (val) => {
  console.log(val);
  ruleForm.cityId = null;
  let params = {
    provinceId: val.split("-")[0],
  };
  let res = await getCityLevel(params);
  console.log(res, "市数据");
  cityList.value = res.data;
};

// 确认添加员工
const submitAdd = lodash.debounce(async (formEl) => {
  if (!formEl) return;
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      let data = {
        name: ruleForm.name,
        categoryId: ruleForm.categoryId.split("-")[0],
        categoryName: ruleForm.categoryId.split("-")[1],
        province: ruleForm.provinceId.split("-")[1],
        provinceId: ruleForm.provinceId.split("-")[0],
        city: ruleForm.cityId.split("-")[1],
        cityId: ruleForm.cityId.split("-")[0],
        description: ruleForm.description,
        contractPerson: ruleForm.contractPerson,
        contractInfo: ruleForm.contractInfo,
        branchIde: ruleForm.branchIde,
        isTop: ruleForm.isTop,
      };
      let res = "";
      if (dialongTitle.value == "创建组织") {
        res = await insertClubData(data);
      } else {
        data.id = ruleForm.id;
        res = await updateClubData(data);
      }
      if (res.code == 200) {
        addDialogVisible.value = false;
        ElMessage({
          type: "success",
          showClose: true,
          message: res.message,
          center: true,
        });
        getList();
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: res.message,
          center: true,
        });
      }
    } else {
      console.log("error submit!", fields);
    }
  });
}, 1000);

const cancelAdd = () => {
  addDialogVisible.value = false;
};

const clubTopupClick = async (row) => {
  let params = {
    id: row.id,
    isTop: 1,
  };
  let res = await clubTopup(params);
  if (res.code == 200) {
    getList();
    ElMessage({
      type: "success",
      showClose: true,
      message: res.message,
      center: true,
    });
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

// 多选框功能
const handleSelectionChange = (val) => {
  // console.log(val);
  selectIds.value = val.map((i) => i.id);
  console.log(selectIds.value);
};

// 表格斑马纹颜色修改
const tableRowClassName = ({ row, rowIndex }) => {
  if (rowIndex % 2 === 0) {
    return "even";
  } else if (rowIndex % 2 !== 0) {
    return "odd";
  }
  return "";
};
// 每页显示条数
const handleSizeChange = (value) => {
  console.log(value, "每页显示条数");
  pageSize.value = value;
};
// 分页
const handleCurrentChange = (value) => {
  // console.log(value);
  currentPage.value = value;
};

const cancelProjectImport = () => {
  buildImportVisible.value = false;
  if (buildRef.value) {
    buildRef.value.clearFiles();
    buildFile.value = null;
  }
};

const categoryList = async () => {
  let res = await getQueryCategoryDatas();
  // console.log(res, "相册分类下拉列表数据");
  if (res.code == 200) {
    categoryData.value = res.data;
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

const provinceData = async () => {
  let res = await getProvinceLevel();
  console.log(res, "省数据");
  if (res.code == 200) {
    provinceList.value = res.data;
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};
const cityData = async (provinceId) => {
  let params = {
    provinceId,
  };
  let res = await getCity(params);
  console.log(res, "市数据");
  if (res.code == 200) {
    return res.data;
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

onBeforeMount(() => {
  getList();
  categoryList();
  provinceData();
});
onUnmounted(() => {
  // document.removeEventListener("keyup", Enters);
});
</script>

<style scoped lang="scss">
.scroll {
  width: calc(100% - 60px);
  height: calc(100% - 61px);
  margin: 0 auto;
  display: flex;
  flex-direction: column;

  .middle {
    width: calc(100%);
    color: #000;
    .filter {
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      .search {
        margin-left: 0 !important;
        color: #fff;
      }
      .condition {
        display: flex;
        align-items: center;
        margin: 10px 30px 10px 0;
        :deep(.el-input .el-input__inner) {
          font-size: 14px;
        }
        .el-select {
          width: 220px;
        }
        span {
          margin: 0 10px 0 0;
        }
      }
    }
    .gongneng {
      margin: 10px 0;
      .el-button {
        color: #fff;
        margin-right: 15px;
      }
    }
  }
  .footer {
    width: calc(100%);
    flex: 1;
    margin: 0 auto;
    overflow: auto;

    .el-table--fit {
      height: calc(100% - 60px);
      :deep(.el-table__header-wrapper) {
        background-color: #000;
        font-size: 15px;
        color: #000;
        .cell {
          color: #000;
        }
      }
      :deep(.el-table__row) {
        height: 50px;
        font-size: 15px;
        color: #000;
      }
      :deep(.el-table__row td) {
        padding: 0;
        border: 0;
      }

      .el-button--primary {
        margin-left: 5px;
      }
      :deep(.el-table__body .even) {
        background-color: #fff;
      }
      :deep(.el-table__body .odd) {
        background-color: rgba(240, 243, 247, 1);
      }
    }

    .pageSize {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin: 0 30px;
      height: 60px;

      span {
        color: #000;
      }

      .el-pagination {
        // width: 1600px;
        :deep(.el-pagination__total) {
          color: #000;
        }

        :deep(.el-pagination__goto) {
          color: #000;
        }

        :deep(.el-pagination__classifier) {
          color: #000;
        }

        :deep(.el-input__wrapper) {
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          box-shadow: none;
        }

        :deep(.el-pager li) {
          margin: 0 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }

        :deep(.el-pager li.is-active) {
          // background-color: rgba(0, 97, 255, 0.8);
          border: 1px solid rgba(0, 97, 255, 1);
          color: rgba(0, 97, 255, 1);
        }

        :deep(.btn-prev) {
          margin-right: 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }

        :deep(.btn-next) {
          margin-left: 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }
      }
    }
  }
}

// 添加员工弹窗样式
.addStaff {
  .el-dialog__body {
    padding: 20px 20px 10px 20px;
    .el-input {
      width: 400px;
    }
    .el-textarea {
      width: 400px;
    }
    .el-select {
      width: 400px;
    }
    .el-form-item {
      :deep(.el-form-item__content) {
        .el-cascader {
          .el-input {
            width: 400px;
          }
        }
      }
    }
    // .el-tree {
    //   width: 400px;
    // }
  }
}
</style>
